;## encoding utf-8 ##

;This script is no Image-Effect.
;Offer the some operations of Layer for use by Shortcut-Key.
;
;-Grouping     [Layer]
;    Active-Layer grouping to Lower-Layer.
;    If Lower-Layer is Group then move to top of its children.
;    If not Group then create new Group, and It will its child Layer with Lower-Layer.
;
;-Leave Group  [Layer]
;    Move to upper of parent Layer(Group).
;    If group's rest children is less than two then Group will disbanded.
;
;-Fuzzy Merge  [Layer]
;    Both the "Merge Down" and "Merge Group Layer".
;    Can performs both is one Key.
;    also, if Lower-Layer is invisible then remove it.
;
;-As New Image [Layer]
;    Create new Image from Active-Layer.
;    If Group-Layer is duplicate the layers tree.
;
;-Nothing      [Select]
;    Both the "None(select)" and "Anchor Layer(floating layer)".
;    If "floating" attached layer is not empty then anchor to new layer of upper of it.

;---------------------------------------------------------------
;これは画像に効果を与えるスクリプトではありません。
;ショートカットキーからの利用を想定した、レイヤ操作用のスクリプト集です。
;
;・グループ化            [レイヤー]
;    下のレイヤとグループ化します
;    下のレイヤがレイヤグループの場合、その先頭の子になります
;    通常レイヤの場合、新規レイヤグループを作成し、下のレイヤと共にその子になります
;
;・グループ解除          [レイヤー]
;    レイヤグループを離脱し、親レイヤの上の位置へ移動します
;    レイヤグループ内の残りの子が1つ以下なら、そのグループ自体を解散します
;
;・ファジー統合          [レイヤー]
;    「下のレイヤーと統合」と「レイヤーグループの統合」を切り替えて行います
;    両方の機能を同じキーで実行させる為のものです
;    グループの親レイヤならグループ統合、その他は下と統合です
;    また、下や子のレイヤが非表示状態なら削除します
;
;・レイヤーを新規画像に  [レイヤー]
;    レイヤを新規画像として開きます
;    対象がレイヤグループの場合、階層構造もそのまま複製します
;
;・全選択解除            [選択]
;    「選択を解除」と「(フローティング)レイヤーを固定」を一緒に行います
;    似た事するのにキー使い分けとか面倒臭いんです…
;    フローティグの固定先レイヤが空では無い場合、その上に新規レイヤを作って固定化します


;---- 処理用関数 -----------------------------------------------
(define (_bool? x) (cond ((boolean? x) x) ;使い分けめんどくさい
	((null? x) #f) ((number? x) (if (zero? x) #f #t)) ((list? x) (_bool? (car x)))
	((string? x) (if (equal? x "") #f #t)) ((vector? x) (_bool? (vector-ref x 0))) (#t x)
))
(define (_layer? x) (if (_bool? (gimp-item-is-valid x)) (if (_bool? (gimp-item-is-layer x)) #t #f) #f) )
(define (_group? x) (if (_bool? (gimp-item-is-valid x)) (if (_bool? (gimp-item-is-group x)) #t #f) #f) )
(define (_visible? x) (if (_bool? (gimp-item-is-valid x)) (if (_bool? (gimp-item-get-visible x)) #t #f) #f) )

;for Japanese ...too eccentric examination
(define _JAP? #f) (gimp-context-push) (gimp-context-set-foreground '(0 0 0))
(python-fu-eval 1 "from os import environ\nfor env in('LANGUAGE','LC_ALL','LC_MESSAGE','LANG'):\n val=environ.get(env)\n if(val):\n  if(val.split(':')[0][:2]=='ja'):pdb.gimp_context_set_foreground((255,0,0))")
(if (> (caar (gimp-context-get-foreground))  0) (set! _JAP? #t)) (gimp-context-pop)

;---- レイヤ序列移動 -------------------------------------------
(define (layer-reposition inLayer inParent inPos inName)
	(if (_layer? inLayer) (let*
		( (inImage (car (gimp-item-get-image inLayer)))
			(vParent (car (gimp-item-get-parent inLayer)))
			(vAct (car (gimp-image-get-active-layer inImage)))
			(vLayer 0) (vB 0) )
		(if (equal? vAct inLayer) (set! vAct 0))
		(if (_group? inParent) (set! vB (car (gimp-item-get-children inParent)))
			(begin (set! inParent 0) (set! vB (car (gimp-image-get-layers inImage))) ) )
		(if (< vB 1) (set! inPos 0))
		(while (< inPos 0) (set! inPos (+ inPos vB))) ;if [inPos<0] is index from bottom
		(set! vLayer (car (gimp-layer-copy inLayer 1)))
		(gimp-item-set-name vLayer (if (_bool? inName) inName (car (gimp-item-get-name inLayer))))
		(gimp-image-remove-layer inImage inLayer)
		(gimp-image-insert-layer inImage vLayer inParent inPos)
		(if (_bool? vAct) (gimp-image-set-active-layer inImage vAct))
		vLayer
	))
)

;---- レイヤグループ統合 ---------------------------------------
(define (layer-group-combine inGroup)
	(if (_group? inGroup) (let*
		( (inImage (car (gimp-item-get-image inGroup)))
			(vChild (vector->list (cadr (gimp-item-get-children inGroup))))
			(vParent (car (gimp-item-get-parent inGroup)))
			(vLock (car (gimp-item-get-lock-content inGroup)))
			(vPos 0) (vLayer 0) )
		(gimp-item-set-lock-content inGroup 0)
		(set! vChild (map (lambda (x) (if (_group? x) (layer-group-combine x) x)) vChild))
		(map (lambda (x) (if (_visible? x) (gimp-item-set-lock-content x 0) (if (_layer? x) (gimp-image-remove-layer inImage x)))) vChild)
		(set! vChild (vector->list (cadr (gimp-item-get-children inGroup))))
		(if (> (length vChild) 0) (begin
			(set! vPos (- (length vChild) 2)) (set! vLayer (nth (- (length vChild) 1) vChild))
			(while (>= vPos 0)
				(set! vLayer (car (gimp-image-merge-down inImage (nth vPos vChild) 0)))
				(set! vPos (- vPos 1)) )
			(if (_layer? vLayer) (let*
				( (vA (car (gimp-item-get-name inGroup))) )
				(gimp-item-set-name inGroup "#del")
				(set! vLayer (layer-reposition vLayer vParent (car (gimp-image-get-item-position inImage inGroup)) vA))
				(gimp-item-set-visible vLayer (car (gimp-item-get-visible inGroup)))
				(gimp-item-set-lock-content vLayer vLock)
			))
		) (set! vLayer '()))
		(gimp-image-remove-layer inImage inGroup)
		(set! inGroup vLayer)
	))
)


;==== レイヤグループ化 =========================================
(define (script-fu-layer-group-in inImage inLayer)
	(if (_layer? inLayer) (let*
		( (vParent (car (gimp-item-get-parent inLayer)))
			(vGroup (vector->list (cadr (if (> vParent 0) (gimp-item-get-children vParent) (gimp-image-get-layers inImage)))))
			(vPos (+ (car (gimp-image-get-item-position inImage inLayer)) 1))
			(vTarget (if (< vPos (length vGroup)) (nth vPos vGroup) -1)) )
		(if (> vTarget 0) (begin (gimp-image-undo-group-start inImage)
			(if (not (_group? vTarget)) (let*
				( (vA (car (gimp-item-get-name vTarget)))
					(vB (car (gimp-layer-group-new inImage))) )
				(gimp-item-set-name vTarget (string-append vA " #base"))
				(gimp-item-set-name vB vA)
				(gimp-image-insert-layer inImage vB vParent vPos)
				(layer-reposition vTarget vB 0 "") (set! vTarget vB)
			))
			(set! inLayer (layer-reposition inLayer vTarget 0 ""))
			(gimp-image-set-active-layer inImage inLayer)
			(gimp-image-undo-group-end inImage) (gimp-displays-flush)
			inLayer
		))
	) inLayer)
)
(script-fu-register
	"script-fu-layer-group-in"
	(if _JAP? "グループ化" "Grouping")
	(if _JAP? "下のレイヤとグループ化" "Grouping to lower layer, or group")
	"HongKong" "" "2015" "*" SF-IMAGE "image" 0 SF-DRAWABLE "drawable" 0 )
(script-fu-menu-register "script-fu-layer-group-in" "<Image>/Layer/New/")
(script-fu-menu-register "script-fu-layer-group-in" "<Layers>/New/")


;==== レイヤグループ(離脱)解除 =================================
(define (script-fu-layer-group-out inImage inLayer)
	(if (_layer? inLayer) (let*
		( (vParent (car (gimp-item-get-parent inLayer))) )
		(if (> vParent 0) (let*
			( (vRoot (car (gimp-item-get-parent vParent)))
				(vPos (car (gimp-image-get-item-position inImage vParent)))
				(vLen (car (gimp-item-get-children vParent)))
				(vA (car (gimp-item-get-name vParent))) (vB 0) )
			(gimp-image-undo-group-start inImage)
			(set! inLayer (layer-reposition inLayer vRoot vPos ""))
			(cond ((< vLen 2) (set! vB inLayer))
				((< vLen 3) (set! vB (layer-reposition (vector-ref (cadr (gimp-item-get-children vParent)) 0) vRoot (+ vPos 1) ""))))
			(if (> vB 0) (begin (gimp-item-set-name vParent "#del") (gimp-item-set-name vB vA)
				(gimp-item-set-visible vB (car (gimp-item-get-visible vParent)))
				(gimp-image-remove-layer inImage vParent)))
			(gimp-image-set-active-layer inImage inLayer)
			(gimp-image-undo-group-end inImage) (gimp-displays-flush)
		))
		inLayer
	))
)
(script-fu-register
	"script-fu-layer-group-out"
	(if _JAP? "グループ解除" "Leave Group")
	(if _JAP? "グループ外に移動、またはグループ解散" "Moved out of group, or Disband group")
	"HongKong" "" "2015" "*" SF-IMAGE "image" 0 SF-DRAWABLE "drawable" 0 )
(script-fu-menu-register "script-fu-layer-group-out" "<Image>/Layer/New/")
(script-fu-menu-register "script-fu-layer-group-out" "<Layers>/New/")


;==== レイヤ統合(ファジー) =====================================
(define (script-fu-layer-merge-fuzzy inImage inLayer)
	(if (_layer? inLayer) (let*
		( (vParent (car (gimp-item-get-parent inLayer))) (vA 0)
			(vGroup (vector->list (cadr (if (> vParent 0) (gimp-item-get-children vParent) (gimp-image-get-layers inImage)))))
			(vPos (+ (car (gimp-image-get-item-position inImage inLayer)) 1)) )
		(if (or (< vPos (length vGroup)) (_group? inLayer) ) (begin
			(gimp-image-undo-group-start inImage) (gimp-context-push)
			(cond ((_group? inLayer) (set! inLayer (layer-group-combine inLayer)))
				((< vPos (length vGroup)) (set! vA (nth vPos vGroup))
					(if (_group? vA) (set! vA (layer-group-combine vA)))
					(if (_layer? vA) (gimp-item-set-lock-content vA 0))
					(cond
						((_visible? vA) (set! inLayer (car (gimp-image-merge-down inImage inLayer 0))))
						((_layer? vA) (gimp-image-remove-layer inImage vA)) ) ) )
			(if (_layer? inLayer) (gimp-image-set-active-layer inImage inLayer))
			(gimp-context-pop) (gimp-image-undo-group-end inImage) (gimp-displays-flush) inLayer
		))
	))
)
(script-fu-register
	"script-fu-layer-merge-fuzzy"
	(if _JAP? "ファジー統合" "Fuzzy Merge")
	(if _JAP? "状況に応じてレイヤーを統合" "Change the merging depending on the situation")
	"HongKong" "" "2015" "*" SF-IMAGE "image" 0 SF-DRAWABLE "drawable" 0 )
(script-fu-menu-register "script-fu-layer-merge-fuzzy" "<Image>/Layer/New/")
(script-fu-menu-register "script-fu-layer-merge-fuzzy" "<Layers>/New/")


;==== レイヤを新規画像化 =======================================
(define (script-fu-image-from-layer inImage inLayer)
	(set! inLayer (car (gimp-image-get-active-layer inImage)))
	(if (_layer? inLayer) (let*
		( (vB (car (gimp-edit-named-copy inLayer "tmp"))) )
		(if (_bool? vB) (let*
			( (vWidth (car (gimp-buffer-get-width vB)))
				(vHeight (car (gimp-buffer-get-height vB)))
				(vNew (car (gimp-image-new vWidth vHeight (car (gimp-image-base-type inImage)))))
				(vLayer (car (gimp-layer-new-from-drawable inLayer vNew))) ) ;;<= Nice Method!
			(gimp-buffer-delete vB) (gimp-context-push) (gimp-image-undo-freeze vNew)
			(gimp-image-insert-layer vNew vLayer 0 0) (gimp-layer-set-offsets vLayer 0 0)
			(gimp-item-set-name vLayer (car (gimp-item-get-name inLayer)))
			(let*
				( (vFile (car (gimp-image-get-filename inImage)))
					(vLen (string-length vFile)) (vA (- vLen 1))
					(vName (car (gimp-item-get-name inLayer))) )
				(set! vName (list->string (filter (lambda (x) (null? (filter (lambda (y) (equal? x y)) (string->list "\"*,/:;<>?\\|")))) (string->list vName))))
				(while (>= vA 0)
					(if (equal? (string-ref vFile vA) #\\) (begin
						(set! vName (string-append (substring vFile 0 (+ vA 1)) vName))
						(set! vA (- 1))) (set! vA (- vA 1))))
				(set! vA (- vLen 1))
				(while (>= vA 0)
					(if (equal? (string-ref vFile vA) #\.) (begin
						(set! vName (string-append vName (substring vFile vA vLen)))
						(set! vA (- 1))) (set! vA (- vA 1))))
				(gimp-image-set-filename vNew vName)
			)
			(gimp-image-clean-all vNew) (gimp-display-new vNew) (gimp-displays-flush)
			(gimp-context-pop) (gimp-image-undo-thaw vNew)
		))
	))
)
(script-fu-register
	"script-fu-image-from-layer"
	(if _JAP? "レイヤーを新規画像に" "As New Image")
	(if _JAP? "レイヤーを新規画像として開く" "Open the Layer as a new Image")
	"HongKong" "" "2015" "*" SF-IMAGE "image" 0 SF-DRAWABLE "drawable" 0
)
(script-fu-menu-register "script-fu-image-from-layer" "<Image>/Layer/New/")
(script-fu-menu-register "script-fu-image-from-layer" "<Layers>/New/")
;(script-fu-menu-register "script-fu-image-from-layer" "<Image>/File/Create/Acquire/")


;==== 選択解除(ファジー) =======================================
(define (script-fu-selection-all-clear inImage inLayer)
	(let* ( (vSel (car (gimp-image-floating-selection inImage))) )
		(if (or (> vSel 0) (= (car (gimp-selection-is-empty inImage)) 0)) (begin
			(gimp-context-push) (gimp-image-undo-group-start inImage)
			(if (> vSel 0) (let*
				( (vLayer (car (gimp-image-floating-sel-attached-to inImage)))
					(vParent (if (< vLayer 0) 0 (car (gimp-item-get-parent vLayer))))
					(vPos (if (< vLayer 0) 0 (car (gimp-image-get-item-position inImage vLayer)))) )
				(if (> vLayer 0) (begin
					(gimp-selection-layer-alpha vLayer)
					(if (_bool? (car (gimp-selection-is-empty inImage))) (begin
						(gimp-floating-sel-anchor vSel) (set! vSel (- 1))
					))
				))
				(if (> vSel 0) (begin (gimp-floating-sel-to-layer vSel)
					(if (< vParent 1) (set! vPos (- vPos 1)))
					(layer-reposition vSel vParent vPos "") ))
			))
			(gimp-selection-none inImage) ;取り敢えず選択解除は必ず
			(gimp-context-pop) (gimp-image-undo-group-end inImage)
			(gimp-displays-flush)
		))
	)
)
(script-fu-register
	"script-fu-selection-all-clear"
	(if _JAP? "全選択解除" "Nothing")
	(if _JAP? "選択範囲の解除とフローティング固定" "Dismiss the selection and Anchor the float")
	"HongKong" "" "2015" "*" SF-IMAGE "image" 0 SF-DRAWABLE "drawable" 0
)
(script-fu-menu-register "script-fu-selection-all-clear" "<Image>/Select/")


