;;; line-nova-gt.scm for gimp-2.x -*-scheme-*-
;;; Time-stamp: <1998/11/25 13:26:44 narazaki@gimp.org>
;;; Author Shuji Narazaki <narazaki@gimp.org>
;;; Version 0.8  - Updated By GnuTux - 10-2014 - http://gimpchat.com
;;; Version 0.9  - Updated By Graechan 10-2014 - Path Select
;;; Version 0.91 - Updated By Graechan 10-2014 - Gradient Nova
;;; Version 0.92 - Updated By Graechan 10-2014 - Bug Fix


(define (script-fu-line-nova-gt img lyr fill-type nova-color nova-gradient num-of-lines corn-deg offset variation feather invert ellipse)

    (gimp-image-undo-group-start img) ;Graechan   
   
    (let* (         
         (copylyr 0)
       (layer 0)
       (inVectors 0) ;find the active path
         (num-strokes 0) ;get the number of strokes
         (stroke-list 0)
         (stroke-id 0) ;get the stroke id
         (num-points 0)
         (control-points 0)
         (anchor-point1x 0)
         (anchor-point1y 0)
         (anchor-point2x 0)
         (anchor-point2y 0)
         (co-ordCounter 0) ;prepare the co-ordinate counter for anchor-point routines
         (f1 FALSE)
       (lenx 0)
         (leny 0)
         (drw 0)
       (saved-selection (car (gimp-selection-save img)))
       (clearance-selection 0)
       (layer-name 0)      
      )
   
   (set! copylyr (car (gimp-layer-copy lyr TRUE)))
   (gimp-image-add-layer img copylyr (+ (car (gimp-image-get-layer-position img lyr)) 1))
   (set! layer copylyr) 
   (gimp-layer-resize-to-image-size lyr)
   
   (if (not (= (car (gimp-image-get-active-vectors img)) -1))
   (begin
   (set! f1 TRUE)
   (set! layer lyr)
   (set! inVectors (car (gimp-image-get-active-vectors img))) ;find the active path
   (set! num-strokes (car (gimp-vectors-get-strokes inVectors))) ;get the number of strokes
   (set! stroke-list (vector->list (cadr (gimp-vectors-get-strokes inVectors))))
   (set! stroke-id (car stroke-list)) ;get the stroke id
   (set! num-points (cadr (gimp-vectors-stroke-get-points inVectors stroke-id)))
   (set! control-points (vector->list (caddr (gimp-vectors-stroke-get-points inVectors stroke-id))))         
         
   (set! co-ordCounter 2)
   (while (> co-ordCounter 0)
   (set! anchor-point1x (car control-points))
   (set! control-points (cdr control-points))
   (set! anchor-point1y (car control-points))
   (set! control-points (cdr control-points))
   (set! co-ordCounter (- co-ordCounter 1)))
   (set! control-points  (vector->list (caddr (gimp-vectors-stroke-get-points inVectors stroke-id))))   
   
   (set! co-ordCounter 5)
   (while (> co-ordCounter 0)
   (set! anchor-point2x (car control-points))
   (set! control-points (cdr control-points))
   (set! anchor-point2y (car control-points))
   (set! control-points (cdr control-points))
   (set! co-ordCounter (- co-ordCounter 1)))
   (set! control-points  (vector->list (caddr (gimp-vectors-stroke-get-points inVectors stroke-id))))
   
   (set! lenx (- (max anchor-point1x anchor-point2x) (min anchor-point1x anchor-point2x)))
    (set! leny (- (max anchor-point1y anchor-point2y) (min anchor-point1y anchor-point2y)))
    (set! offset (max lenx leny))   
   )
   )   
   
   (set! drw (car (gimp-layer-new img (car (gimp-drawable-width layer)) (car (gimp-drawable-height layer)) (car (gimp-drawable-type-with-alpha lyr)) "Line Nova" 100 NORMAL-MODE))) ;Graechan
   (gimp-image-add-layer img drw (+ (car (gimp-image-get-layer-position img lyr)) 0))
   (gimp-layer-set-offsets drw (car (gimp-drawable-offsets layer)) (cadr (gimp-drawable-offsets layer))) ;Graechan
   (if (= f1 FALSE) (set! anchor-point1x (/ (car (gimp-drawable-width drw)) 2))) ;Graechan
   (if (= f1 FALSE) (set! anchor-point1y (/ (car (gimp-drawable-height drw)) 2))) ;Graechan
    (gimp-layer-translate drw (- anchor-point1x (/ (car (gimp-drawable-width drw)) 2))   (- anchor-point1y (/ (car (gimp-drawable-height drw)) 2))) ;Graechan
   
   (gimp-ellipse-select img
                       (car (gimp-drawable-offsets copylyr)) ;x
                  (cadr (gimp-drawable-offsets copylyr)) ;y
                  (car (gimp-drawable-width copylyr)) ;width
                  (car (gimp-drawable-height copylyr)) ;height
                  2 ;operation
                  TRUE ;antialias
                  TRUE ;feather
                  feather) ;feather-radius
                     
   (gimp-selection-invert img)
   (set! clearance-selection (car (gimp-selection-save img)))
   (gimp-selection-none img)   
   
   (gimp-selection-load saved-selection)
   (gimp-image-remove-channel img saved-selection)
   
  (let* (
        (*points* (cons-array (* 3 2) 'double))
        (modulo fmod)                        ; in R4RS way
        (pi/2 (/ *pi* 2))
        (pi/4 (/ *pi* 4))
        (pi3/4 (* 3 pi/4))
        (pi5/4 (* 5 pi/4))
        (pi3/2 (* 3 pi/2))
        (pi7/4 (* 7 pi/4))
        (2pi (* 2 *pi*))
        (rad/deg (/ 2pi 360))
        (variation/2 (/ variation 2))
        (drw-width (car (gimp-drawable-width drw)))
        (drw-height (car (gimp-drawable-height drw)))
        (drw-offsets (gimp-drawable-offsets drw))
        (old-selection 0)
      (f2 FALSE)
        (radius (max drw-height drw-width))
        (index 0)
        (dir-deg/line (/ 360 num-of-lines))      
        )
   
    (gimp-context-push)
    (gimp-context-set-foreground nova-color)
   (gimp-context-set-gradient nova-gradient)
    (gimp-layer-resize-to-image-size drw) ;Graechan
   
    (define (draw-vector beg-x beg-y direction)

      (define (set-point! index x y)
            (aset *points* (* 2 index) x)
            (aset *points* (+ (* 2 index) 1) y)
      )
      (define (deg->rad rad)
            (* (modulo rad 360) rad/deg)
      )
      (define (set-marginal-point beg-x beg-y direction)
        (let (
             (dir1 (deg->rad (+ direction corn-deg)))
             (dir2 (deg->rad (- direction corn-deg)))
             )

          (define (aux dir index)
                   (set-point! index
                               (+ beg-x (* (cos dir) radius))
                               (+ beg-y (* (sin dir) radius)))
          )

          (aux dir1 1)
          (aux dir2 2)
        )
      )

      (let (
           (dir0 (deg->rad direction))
           (off (+ offset (- (modulo (rand) variation) variation/2)))
           )

        (set-point! 0
                    (+ beg-x (* off (cos dir0)))
                    (+ beg-y (* off (sin dir0)))
        )
        (set-marginal-point beg-x beg-y direction)
        (gimp-image-select-polygon img CHANNEL-OP-ADD 6 *points*)
      )
    )
   
    (if (= (car (gimp-selection-is-empty img)) FALSE) (begin
   (set! old-selection (car (gimp-selection-save img)))
   (set! f2 TRUE)
   )
    )   

    (gimp-selection-none img)
    (srand (realtime))
    (while (< index num-of-lines)
      (draw-vector (+ (nth 0 drw-offsets) (/ drw-width 2))
                   (+ (nth 1 drw-offsets) (/ drw-height 2))
                   (* index dir-deg/line)
      )
      (set! index (+ index 1))
    )

    (if (= invert FALSE)
      (gimp-selection-invert img)
    )
   
    (gimp-edit-bucket-fill drw 0 0 100 0 FALSE 0 0)
   
   (if (= fill-type 1)
    (begin
(let* (
         (x1 anchor-point1x)
          (y1 anchor-point1y)
          (x2 0)
          (y2 0)
        )   
   
    (set! x2 (cond ((> anchor-point1x (- (car (gimp-drawable-width layer)) anchor-point1x)) (car (gimp-drawable-offsets layer)))
             (else (car (gimp-drawable-width layer)))))
    (set! y2 (cond ((> anchor-point1y (- (car (gimp-drawable-height layer)) anchor-point1y)) (cadr (gimp-drawable-offsets layer)))
             (else (car (gimp-drawable-height layer)))))
   
   (gimp-edit-blend drw CUSTOM-MODE NORMAL-MODE GRADIENT-RADIAL 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE x1 y1 x2 y2)
    ) ;end gradient fill   
    )
   ) ;endif
   
   (gimp-rect-select img
                        (car (gimp-drawable-offsets copylyr))
                        (cadr (gimp-drawable-offsets copylyr))
                        (car (gimp-drawable-width copylyr)) ;width
                  (car (gimp-drawable-height copylyr)) ;height
                  CHANNEL-OP-REPLACE ;operation{ CHANNEL-OP-ADD (0), CHANNEL-OP-SUBTRACT (1), CHANNEL-OP-REPLACE (2), CHANNEL-OP-INTERSECT (3) }
                  FALSE ;feather
                  0)  ;feather radious
   
   (let ((pasted 0))
   (gimp-edit-cut drw)
   (gimp-image-remove-layer img drw)
   (set! drw (car (gimp-layer-new img (car (gimp-drawable-width copylyr)) (car (gimp-drawable-height copylyr)) (car (gimp-drawable-type-with-alpha lyr)) "Line Nova" 100 NORMAL-MODE))) ;Graechan
    (gimp-image-add-layer img drw -1) ;Graechan
   (gimp-layer-set-offsets drw (car (gimp-drawable-offsets copylyr)) (cadr (gimp-drawable-offsets copylyr))) ;Graechan
   (set! pasted (car (gimp-edit-paste drw FALSE)))
   (gimp-floating-sel-anchor pasted))
   (set! layer-name (car (gimp-drawable-get-name lyr)))
   (set! lyr (car (gimp-image-merge-down img lyr CLIP-TO-BOTTOM-LAYER)))
   (gimp-drawable-set-name lyr layer-name)
   (gimp-image-set-active-layer img drw)
   
   (if (or (= ellipse TRUE) (= f1 TRUE))
   (begin
   (gimp-selection-load clearance-selection)
   (gimp-edit-clear drw)
   )
   )
   (gimp-image-remove-channel img clearance-selection)
   (gimp-selection-none img)

    (if (= f2 TRUE)
     (begin
        (gimp-image-select-item img CHANNEL-OP-REPLACE old-selection)
        (gimp-image-remove-channel img old-selection)
      )
    )
   
    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
    (gimp-context-pop)
    ) ;end script variables

   ); end path variables
) ;end procedure


(script-fu-register "script-fu-line-nova-gt"
  _"Line Nova GT..."
  _"Fill a layer with rays emanating outward from its center using selected color"
  "Shuji Narazaki <narazaki@gimp.org>"
  "Shuji Narazaki - GnuTux - Graechan"
  "1997,1998,2014"
  "*"
  SF-IMAGE       "Image"                 0
  SF-DRAWABLE    "Drawable"              0
  SF-OPTION     _"Nova Fill Type"        '("Color" "Gradient")
  SF-COLOR      _"Nova Color"            '(255 231 72)
  SF-GRADIENT   _"Nova Gradient"         "Abstract 3"
  SF-ADJUSTMENT _"Number of lines"       '(200 40 1000 1 1 0 1)
  SF-ADJUSTMENT _"Sharpness (degrees)"   '(1.0 0.0 10.0 0.1 1 1 1)
  SF-ADJUSTMENT _"Offset radius"         '(40 0 2000 1 1 0 1)
  SF-ADJUSTMENT _"Randomness"            '(30 1 2000 1 1 0 1)
  SF-ADJUSTMENT _"Ellipse Feather Value" '(15 0 30 1 5 0 1)
  SF-TOGGLE     _"Invert Nova"         FALSE
  SF-TOGGLE     _"Ellipse Default:(only if path = null)"         FALSE
 
)

(script-fu-menu-register "script-fu-line-nova-gt"
                         "<Image>/Filters/Render")

