#!/usr/bin/env python

from gimpfu import *
from string import *

def layer_names( timg, tdrawable, delay_ms ):
	#gimp.message( str("OLOLO") )
	num_layers, layer_ids = pdb.gimp_image_get_layers( timg )
	layers = timg.layers
	for iLayer in range(num_layers):
		layers[iLayer].name = "Frame #{0} ({1}ms)".format( num_layers-1-iLayer, delay_ms )

register(
	"plug-in-layer-names",   # name
	"Set number of milliseconds to delay each frame:",  # blurb (ad)
	"Test layer names help", # help
	"Alexey Min",            # author
	"Alexey Min",            # copyright
	"2013",                  # date
	#"<Image>/Script-Fu/Python/_Test...", # menupath
	"<Image>/Filters/Animation/Set frames delay...", # menupath
	"RGB*, GRAY*",           # imagetypes
	# params
	[
		(PF_INT, "delay_ms", "Delay (ms)", 100)  # (type, name, desc, default)
	],
	# results
	[],  # (type, name, description)
	layer_names ) # function

main()